var OAAS_VIEW = (function (my, _, $, Backbone) {
    my.DatatypeMapper = function () {
        this.cb = {};
        _.extend(this.cb, Backbone.Events);

        this.mapHtml = function (property, el) {
            var parameter = property.Value;
            var key = property.Name;
            if (property.Options) {
                var osv = new OAAS_VIEW.SelectionView({ model: property, el: el });
                this.cb.listenTo(osv, 'selected', function (model) {
                    property.Value = model.value;
                });
                osv.render();
                return osv;
            }
            else if (parameter instanceof Array) {
                // parameter is a matrix or vector of numbers
                var tev = new OAAS_VIEW.TableEditView({ model: parameter, el: el, editable: true });
                tev.render();
                return tev;
            }
            else if (typeof (parameter) == 'boolean') {
                var osv = new OAAS_VIEW.OptionSelectionView({ model: parameter, el: el, hideText: true });
                this.cb.listenTo(osv, 'changed', function (model) {
                    property.Value = model.checked;
                });
                osv.render();
                return osv;
            }
            // parameter is a number
            else if (!isNaN(parameter)) {
                var nev = new OAAS_VIEW.NumberEditableView({ model: property, el: el });
                nev.render();
                return nev;
            }
            return 'No mapping for ' + typeof (parameter) + ' (Key: ' + key + ')';
        };


    }


    function DatatypeMapper_mapStrings(key, param, selected) {
        // http://stackoverflow.com/questions/4814512/how-to-create-dropdown-list-dynamically-using-jquery
        var s = $('<select name="' + key + '"/>');
        for (var i = 0; i < param.length; i++) {
            $('<option />', { value: param[i], text: param[i] }).appendTo(s);
        }
        s.val(selected);
        return s;
    }

    function DatatypeMapper_mapNumber(key, param) {
        return $('<input type="text" name="' + key + '" />').val(param);
    }

    function DatatypeMapper_mapBoolean(key, param) {
        var s = $('<select name="' + key + '"/>');
        $('<option />', { value: 'true', text: 'true' }).appendTo(s);
        $('<option />', { value: 'false', text: 'false' }).appendTo(s);
        return s;
    }

    function DatatypeMapper_mapNumbers(key, param) {
        // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
        var table = $('<table></table>').addClass('editableTable');
        var head = $('<thead></thead>');
        // create head elements
        var headerRow = $('<tr></tr>');
        $('<td />').text(key + ' Column').appendTo(headerRow);
        headerRow.appendTo(head);
        head.appendTo(table);
        var body = $('<tbody></tbody>');
        for (var i = 0; i < param.length; i++) {
            var row = $('<tr></tr>');
            var td = $('<td />').appendTo(row);
            $('<input type="text" name="' + key + '_' + i + '" />').val(param[i]).appendTo(td);
            row.appendTo(body);
        }
        body.appendTo(table);
        return table;
    }

    function DatatypeMapper_mapMatrix(key, param) {
        // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
        var table = $('<table></table>').addClass('editableTable');
        var head = $('<thead></thead>');
        // create head elements
        var headerRow = $('<tr></tr>');
        for (var i = 0; i < param[0].length; i++) {
            $('<td />').text(key + ' Column ' + i).appendTo(headerRow);
        }
        headerRow.appendTo(head);
        head.appendTo(table);
        var body = $('<tbody></tbody>');
        for (var i = 0; i < param.length; i++) {
            var row = $('<tr></tr>');
            for (var j = 0; j < param[i].length; j++) {
                var td = $('<td />').appendTo(row);
                $('<input type="text" name="' + key + '_' + i + '_' + j + '" />').val(param[i][j]).appendTo(td);
            }
            row.appendTo(body);
        }
        body.appendTo(table);
        return table;

        /*var table = '<table class="editableTable"><thead><tr>';
        for (var i = 0; i < param[0].length; i++) {
        table += '<th>' + key + ' Column ' + (i + 1) + '</th>';
        }
        table += '</tr>';
        // foreach value entry (2d entry)
        for (var i = 0; i < param.length; i++) {
        table += '<tr>';
        for (var j = 0; j < param[i].length; j++) {
        table += '<td><input type="text" name="' + key + '_' + i + '_' + j + '" /></td>';
        }
        table += '</tr>';
        }
        return $*/
    }

    /*
    DatatypeMapper.prototype.mapString = function (value) {
    if (value == "true") return true;
    else if (value == "false") return false;
    else if (!isNaN(value)) return parseFloat(value.replace(',', '.'));
    return value;
    }

    DatatypeMapper.prototype.aggregateTables = function (data) {
    // aggregate tables:
    for (var dataKey in data) {
    var entry = data[dataKey];
    var tableEntries = {};
    var toRemove = [];
    for (var key in entry) {
    if (key.indexOf('_') != -1) {
    var splitted = key.split('_');
    var name = splitted[0];
    var row = parseInt(splitted[1]);
    if (!(name in tableEntries)) {
    tableEntries[name] = []
    }

    if (splitted.length == 2) { // its a vector of elements
    tableEntries[name].push(entry[key])
    } else if (splitted.length == 3) { // its a matrix of elements
    column = parseInt(splitted[2]);
    if (tableEntries[name].length < row + 1)
    tableEntries[name].push([]);
    tableEntries[name][row][column] = entry[key];
    }
    toRemove.push(key);
    }
    }

    for (var i = 0; i < toRemove.length; i++) {
    delete entry[toRemove[i]];
    }

    for (var key in tableEntries) {
    entry[key] = tableEntries[key];
    }
    }
    }*/
    return my;
} (OAAS_VIEW || {}, _, $, Backbone));